                      Computer Science 481/681
                         Quiz A           Name _______________________

1. The TCP protocol is a transport protocol that is

   a. Connection-less and         b. Connection-less and reliable.
      unreliable.

   c. Connection-oriented and     d. Connection-oriented and reliable.
      unreliable.

2. Functions that TCP must perform include

   a. Detect and discard          b. Reorder data that is received
      duplicated data                out of order

   c. Both of the above.          d. Neither of the above.

3. The method used by TCP to deal with datagrams that are lost
   or damaged is:

   a. Simply accept the errors    b. Send a NAK packet explicitly
                                     requesting a retransmission

   c. Have the sender time-out    d. All of the above.
      and retransmit.

4. Reliable transport protocols are more difficult to construct
   than reliable datalink protocols because ("wire" represents any
   physical POINT-TO-POINT connection).
                                           (bandwidth)
   a. An unreliable network layer   b. The throughput on a "wire" is fixed
      can deliver packets out of       but the throughput available to a
      order but a "wire" doesn't.      transport connection varies with load.

   c. The latency on a "wire" is    d. All of the above
      fixed but the latency seen
      by a transport connection
      varies with load.

5. The relationship between sequence number manipulation in TCP and
   in most datalink protocols is that each time a packet is transmitted:

   a. In TCP and in datalink protocols  b. TCP increments by the packet
      sequence numbers are incremented     length while datalink protocols
      by 1.                                increment by 1.

   c. Both TCP and datalink protocols   d. TCP increments by 1 but the
      increment sequence numbers by        datalink protocols increment
      the packet length.                   by the packet length.

6. Answer the following "T" or "F" as it relates to server port 34 on
   a host having IP address 130.127.48.24

   ____ a. Only one TCP session in the world can have this host and port
           address as an endpoint at any point in time.

   ____ b. Client hosts with IP addresses 130.127.48.3 and 130.127.48.5
           can simultaneously have TCP sessions with (130.127.48.24, 34)
           even if both clients use local port 3333.

   ____ c. Client processes having IP address 130.127.48.18 can
           can simultaneously have TCP sessions with (130.127.48.24, 34)
           even if both clients processes use local port 3333.



7. The initial sequence number used in establishing a TCP session
   is supposed to be:

   a. Derived from a clock that  b. The last sequence number
      ticks at constant rate.       used on "this" port + 1

   c. Always 0.                  d. Always 1.



Suppose a 3 way handshake is being used to establish a connection.
Let SYN1 represent a packet that carries SYN and no ack.
Let SYN2 represent a packet that carries both SYN and ACK that is
sent in response to a SYN1

8. A delayed duplicate SYN2  received the SYN sent state is
   detected because:

   a. The SEQ number is wrong.   b. The ACK number is wrong.

   c. Both SEQ and ACK are       d. SYN2 is an unexpected packet
      known to be wrong.            in the SYN sent state.

9. A delayed duplicate SYN1 received in the CLOSED / LISTEN state is

   a. detected because of wrong  b. Detected because of wrong ACK
      SEQ number.                   number.

   c. Undetected and responded   d. Responded to with a SYN 1.
      to with a SYN2.

10. A delayed duplicate SYN1 received in the ESTABLISHED state is:

    a. Responded to with RESET.   b. Responded to with a data packet
                                     specifying current ACK and SEQ.

    c. Responded to with SYN2     d. Always causes TCP to crash.


